#ifndef EFL_IO_SIZER_EO_HH
#define EFL_IO_SIZER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_sizer.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace io { 
struct Sizer;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::Sizer> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct Sizer;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct Sizer {
   ::efl::eolian::return_traits< uint64_t>::type size_get() const;
   ::efl::eolian::return_traits<bool>::type size_set( ::efl::eolian::in_traits< uint64_t>::type size) const;
   ::efl::eolian::return_traits<Eina_Error>::type resize( ::efl::eolian::in_traits< uint64_t>::type size) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_SIZER_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::Sizer() const;
   operator ::efl::io::Sizer&();
   operator ::efl::io::Sizer const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Sizer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Sizer const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct Sizer : ::efl::eo::concrete
{
   explicit Sizer( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Sizer(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Sizer(Sizer const& other) = default;
   Sizer(Sizer&& other) = default;
   Sizer& operator=(Sizer const& other) = default;
   Sizer& operator=(Sizer&& other) = default;
   Sizer()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Sizer( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Sizer(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< uint64_t>::type size_get() const;
   ::efl::eolian::return_traits<bool>::type size_set( ::efl::eolian::in_traits< uint64_t>::type size) const;
   ::efl::eolian::return_traits<Eina_Error>::type resize( ::efl::eolian::in_traits< uint64_t>::type size) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_SIZER_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct size_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_SIZER_EVENT_SIZE_CHANGED; }
      typedef void parameter_type;
   } const size_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Sizer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Sizer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Sizer) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Sizer>::value, "");
} } 
#endif
